DROP DATABASE IF EXISTS `lseed`;
CREATE DATABASE `lseed` ;

CREATE USER 'lseed'@'localhost' IDENTIFIED BY 'GCp:rtAaN8nwTFMP';

REVOKE ALL PRIVILEGES ON * . * FROM 'lseed'@'localhost';
REVOKE GRANT OPTION ON * . * FROM 'lseed'@'localhost';
GRANT SELECT, INSERT, UPDATE, DELETE ON * . * TO 'lseed'@'localhost'
WITH MAX_QUERIES_PER_HOUR 0
MAX_CONNECTIONS_PER_HOUR 0
MAX_UPDATES_PER_HOUR 0;

CREATE TABLE `user` (
	`ID` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
	`Name` VARCHAR( 255 ) NOT NULL ,
	`Password` VARCHAR( 255 ) NOT NULL ,
	`IsAdmin` BOOL NOT NULL ,
	`NextSeed` Int NULL,
	INDEX ( `Name` )
) ENGINE = MYISAM ;

CREATE TABLE `plant` (
	`ID` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
	`UserID` INT NOT NULL ,
	`Name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
	`Code` VARCHAR( 10240 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
	`Valid` BOOL NOT NULL,
	INDEX ( `UserID` )
) ENGINE = MYISAM ;

CREATE TABLE `season` (
	`ID` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
	`IsRunning` BOOL NOT NULL
) ENGINE = MYISAM ;

CREATE TABLE `seasonscore` (
	`ID` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
	`UserID` INT NOT NULL ,
	`SeasonID` INT NOT NULL ,
	`Score` DOUBLE NOT NULL, 
	UNIQUE INDEX ( `UserID`, `SeasonID` )
) ENGINE = MYISAM ;
